std::indirect_array< _Tp > Class Template Reference
Numerics » Numeric Arrays

`#include <indirect_array.h>`

## Public Types

typedef _Tp | value_type

## Public Member Functions

| indirect_array (const indirect_array &)
template<class _Dom >
void | operator%= (const _Expr< _Dom, _Tp > &) const
void | operator%= (const valarray< _Tp > &) const
template<class _Dom >
void | operator&= (const _Expr< _Dom, _Tp > &) const
void | operator&= (const valarray< _Tp > &) const
template<class _Dom >
void | operator*= (const _Expr< _Dom, _Tp > &) const
void | operator*= (const valarray< _Tp > &) const
template<class _Dom >
void | operator+= (const _Expr< _Dom, _Tp > &) const
void | operator+= (const valarray< _Tp > &) const
template<class _Dom >
void | operator-= (const _Expr< _Dom, _Tp > &) const
void | operator-= (const valarray< _Tp > &) const
template<class _Dom >
void | operator/= (const _Expr< _Dom, _Tp > &) const
void | operator/= (const valarray< _Tp > &) const
template<class _Dom >
void | operator<<= (const _Expr< _Dom, _Tp > &) const
void | operator<<= (const valarray< _Tp > &) const
template<class _Dom >
void | operator= (const _Expr< _Dom, _Tp > &) const
void | operator= (const _Tp &) const
indirect_array & | operator= (const indirect_array &)
template<typename _Tp >
indirect_array< _Tp > & | operator= (const indirect_array< _Tp > &__a)
void | operator= (const valarray< _Tp > &) const
template<class _Dom >
void | operator>>= (const _Expr< _Dom, _Tp > &) const
void | operator>>= (const valarray< _Tp > &) const
template<class _Dom >
void | operator^= (const _Expr< _Dom, _Tp > &) const
void | operator^= (const valarray< _Tp > &) const
template<class _Dom >
void | operator|= (const _Expr< _Dom, _Tp > &) const
void | operator|= (const valarray< _Tp > &) const

## Friends

class | gslice_array< _Tp >
class | valarray< _Tp >

## Detailed Description

template<class _Tp>
class std::indirect_array< _Tp >

Reference to arbitrary subset of an array.

An indirect_array is a reference to the actual elements of an array specified by an ordered array of indices. The way to get an indirect_array is to call operator[](valarray<size_t>) on a valarray. The returned indirect_array then permits carrying operations out on the referenced subset of elements in the original valarray.

For example, if an indirect_array is obtained using the array (4,2,0) as an argument, and then assigned to an array containing (1,2,3), then the underlying array will have array[0]==3, array[2]==2, and array[4]==1.

Parameters

  Tp | Element type.

Definition at line 62 of file indirect_array.h.

## Member Typedef Documentation

## value_type

template<class _Tp >

typedef _Tp std::indirect_array< _Tp >::value_type

Definition at line 65 of file indirect_array.h.

## Constructor & Destructor Documentation

## indirect_array()

template<class _Tp >

std::indirect_array< _Tp >::indirect_array | ( | const indirect_array< _Tp > & |  | ) |

Copy constructor. Both slices refer to the same underlying array.

## Member Function Documentation

## operator%=()

template<class _Tp >

void std::indirect_array< _Tp >::operator%= | ( | const valarray< _Tp > & |  | ) | const

Modulo slice elements by corresponding elements of v.

## operator&=()

template<class _Tp >

void std::indirect_array< _Tp >::operator&= | ( | const valarray< _Tp > & |  | ) | const

Logical and slice elements with corresponding elements of v.

## operator*=()

template<class _Tp >

void std::indirect_array< _Tp >::operator*= | ( | const valarray< _Tp > & |  | ) | const

Multiply slice elements by corresponding elements of v.

## operator+=()

template<class _Tp >

void std::indirect_array< _Tp >::operator+= | ( | const valarray< _Tp > & |  | ) | const

Add corresponding elements of v to slice elements.

## operator-=()

template<class _Tp >

void std::indirect_array< _Tp >::operator-= | ( | const valarray< _Tp > & |  | ) | const

Subtract corresponding elements of v from slice elements.

## operator/=()

template<class _Tp >

void std::indirect_array< _Tp >::operator/= | ( | const valarray< _Tp > & |  | ) | const

Divide slice elements by corresponding elements of v.

## operator<<=()

template<class _Tp >

void std::indirect_array< _Tp >::operator<<= | ( | const valarray< _Tp > & |  | ) | const

Left shift slice elements by corresponding elements of v.

## operator=()

template<class _Tp >

indirect_array & std::indirect_array< _Tp >::operator= | ( | const indirect_array< _Tp > & |  | ) |

Assignment operator. Assigns elements to corresponding elements of a.

## operator>>=()

template<class _Tp >

void std::indirect_array< _Tp >::operator>>= | ( | const valarray< _Tp > & |  | ) | const

Right shift slice elements by corresponding elements of v.

## operator^=()

template<class _Tp >

void std::indirect_array< _Tp >::operator^= | ( | const valarray< _Tp > & |  | ) | const

Logical xor slice elements with corresponding elements of v.

## operator|=()

template<class _Tp >

void std::indirect_array< _Tp >::operator|= | ( | const valarray< _Tp > & |  | ) | const

Logical or slice elements with corresponding elements of v.

## Friends And Related Symbol Documentation

## gslice_array< _Tp >

template<class _Tp >

friend class gslice_array< _Tp >

friend

Definition at line 128 of file indirect_array.h.

## valarray< _Tp >

template<class _Tp >

friend class valarray< _Tp >

friend

Definition at line 128 of file indirect_array.h.

The documentation for this class was generated from the following files:

- valarray
- indirect_array.h